<?php
/**
 * Описываыем структуру.
 * В PHP нет возможности указать типы полей (int,real,string,...)
 * просто перечисляем их имена
 */
class PHPTPlayerEx {
    public $dead, $bot, $crouch, $balloon, $flagcarrier, $have_rl, $have_gl, $have_rg, $have_bfg, $have_sg, $have_mg, $have_sh, $have_pl;
    public $refire, $weapchg, $weapon, $threadweapon, $dir, $gantl_state, $air, $team, $item_quad, $item_regen, $item_battle, $item_flight, $item_haste, $item_invis, $ammo_mg, $ammo_sg, $ammo_gl, $ammo_rl, $ammo_sh, $ammo_rg, $ammo_pl, $ammo_bfg;
    public $x, $y, $cx, $cy, $fangle, $InertiaX, $InertiaY;
    public $health, $armor, $frags;
    public $netname, $nfkmodel;
    public $Location;
    public $DXID;
}

/** функция mainLoop должна вызываться 50 раз в секунду. Введём глобальный счётчик и на кажный 100-й вызов будем записывать
 * информацию в лог (раз в 2 секунды)
 */
$loopCount = 0;
function mainLoop() {
    global $loopCount;
    $loopCount++;
    if ($loopCount == 100) {
        //Создадим файл с именем содержащем дату и время с точностью до секунды
        $text = date('Y-m-d H_i_s');
        file_put_contents('mainLoop ' . $text . '.txt', $text);

        //Обнуляем счётчик
        $loopCount = 0;
    }
}
function eventBeginGame() {
    file_put_contents('eventBeginGame.txt', date('Y-m-d H:i:s'));
}

/**
 * Функция возвращает строку
 */
function queryVersion() {
    file_put_contents('queryVersion.txt', date('Y-m-d H:i:s'));
    return "PHP BOT ver 0.1";
}

/**
 * Возможно из Delphi так и не удастся передать в качестве входного параметра объект класса PHPTPlayerEx
 * объявленного в этом PHP скрипте.
 *
 * Запасной план: функция addPlayer2 - она принимает вместо стуктуры простой массив. С массивами наверняка
 * должно получиться
 */
function addPlayer(PHPTPlayerEx $player) {
    //Чтобы протестировать, вызывается ли этот метод, запишем данные в файл
    $text = date('Y-m-d H:i:s') . "\r\n";
    $playerDataAsArray = (array)$player;
    foreach($playerDataAsArray as $key => $val) {
        $text .= $key . ": " . $val . "\r\n";
    }
    file_put_contents('addPlayer.txt', $text);
}

function addPlayer2(array $player) {
    //Чтобы протестировать, вызывается ли этот метод, запишем данные в файл
    $text = date('Y-m-d H:i:s') . "\r\n";
    foreach($player as $key => $val) {
        $text .= $key . ": " . $val . "\r\n";
    }
    file_put_contents('addPlayer2.txt', $text);
}

function removePlayer($dxid) {
    $text = date('Y-m-d H:i:s') . "\r\n";
    $text .= "DDXID : " . $dxid;
    file_put_contents('removePlayer.txt', $text);
}